#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=SpaceBar.ico
#AutoIt3Wrapper_outfile=SpaceBar.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Allow_Decompile=n
#AutoIt3Wrapper_Res_Description=SpaceBar
#AutoIt3Wrapper_Res_Fileversion=3.4.2.5
#AutoIt3Wrapper_Res_LegalCopyright=Ritzelrocker04, Xenobiologist, Oscar and Prog@ndy
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Res_Field=Compiled by|Prog@ndy
#AutoIt3Wrapper_Res_Field=AutoIt Version|3.2.8.1
#AutoIt3Wrapper_Res_Field=Original Name|SpaceBar.exe
#AutoIt3Wrapper_Res_Icon_Add=close.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; by Ritzelrocker04, Xenobiologist, Oscar and Prog@ndy
Opt('MustDeclareVars', 1)
Opt('GUIEventOptions', 1)
Opt('GUIOnEventMode', 1)
Global $title = 'SpaceBar Version: 3.4.2.5'

#include<Misc.au3>
If _Singleton('SpaceBar', 1) = 0 Then
	MsgBox(48, $title, 'Das Programm luft bereits!' & @CRLF & 'Hotkey = ALT + s')
	Exit
EndIf

;[Includes]
#include<Array.au3>
#include<GUIConstants.au3>
#include<String.au3>
#include<Process.au3>

;Extract EjectMedia if not exists
If Not FileExists(@ScriptDir & '\EjectMedia\EjectMedia.exe') Then
	DirCreate(@ScriptDir & "\EjectMedia")
	FileInstall("EjectMedia\EjectMedia.exe", @ScriptDir & "\EjectMedia\EjectMedia.exe")
	FileInstall("EjectMedia\EjectMedia.txt", @ScriptDir & "\EjectMedia\EjectMedia.txt")
EndIf
;Extract RemoveDrive if not exists
If Not FileExists(@ScriptDir & '\RemoveDrive\RemoveDrive.exe') Then
	DirCreate(@ScriptDir & "\RemoveDrive")
	FileInstall("RemoveDrive\RemoveDrive.exe", @ScriptDir & "\RemoveDrive\RemoveDrive.exe")
	FileInstall("RemoveDrive\RemoveDrive.txt", @ScriptDir & "\RemoveDrive\RemoveDrive.txt")
EndIf


If Not IsDeclared('Range') Then Const $Range = 80
If Not IsDeclared('WM_MOVING') Then Const $WM_MOVING = 0x0216
If Not IsDeclared('WM_ENTERSIZEMOVE') Then Const $WM_ENTERSIZEMOVE = 0x0231
If Not IsDeclared('WM_LBUTTONDOWN') Then Global Const $WM_LBUTTONDOWN = 0x0201
If Not IsDeclared('WM_SYSCOMMAND') Then Const $WM_SYSCOMMAND = 0x112
If Not IsDeclared('WM_RBUTTONDOWN') Then Global Const $WM_RBUTTONDOWN = 0x0204
If Not IsDeclared('WM_EXITSIZEMOVE') Then Global Const $WM_EXITSIZEMOVE = 0x232
If Not IsDeclared('WM_CONTEXTMENU') Then Global Const $WM_CONTEXTMENU = 0x7B
	
;Slide-Constants
Global Const $AW_SLIDE_IN_RIGHT = 0x00040002;slide in from right
Global Const $AW_SLIDE_OUT_RIGHT = 0x00050001;slide out to right
Global Const $AW_SLIDE_IN_LEFT = 0x00040001;slide in from left
Global Const $AW_SLIDE_OUT_LEFT = 0x00050002;slide out to left
Global $SlideOUTDirection = $AW_SLIDE_OUT_RIGHT

Global $objWMIService = ObjGet("winmgmts:\\" & "localhost" & "\root\CIMV2") ; Objekt am Anfang erzeugen, statt mehrmals im Script.

Global $pGDFS = DllStructCreate("dword;dword;dword;dword"); zur Berechnung der Clustergre

Global $taskbarPos = WinGetPos('[CLASS:Shell_TrayWnd]'), $x_start, $y_start, $win_move


Global $bREMOVABLE = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'REMOVABLE', True))
Global $bFIXED = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'FIXED', True))
Global $bCDROM = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'CDROM', True))
Global $bNETWORK = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'NETWORK', True))
Global $bRAMDISK = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'RAMDISK', True))

Global $aFDrive[1], $aRemDrive = 0

_GetDrives()

Global $aAllDrives = DriveGetDrive('ALL')
Global $aDriveletter[$aAllDrives[0]][$aAllDrives[0]], $aDeviceName[$aAllDrives[0]], $aCDLN[$aAllDrives[0]][2], $aNtLN[$aAllDrives[0]][2], $aInterface[$aAllDrives[0]]
_CDROMDrive()
_DiskDrive()
_LogicalDiskToPartition()

Global $iPosY = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'Pos', 'iPosY', 188))
Global $bHide = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'Pos', 'bHide', True))
Global $bOnTop = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'Pos', 'bOnTop', True))
Global $iDrive = IniRead(@ScriptDir & '\SpaceBar.ini', 'Pos', 'iDrive', '')

Global $bAutostart = Execute(IniRead(@ScriptDir & '\SpaceBar.ini', 'Pos', 'bAutostart', False))
If $bAutostart And @Compiled Then
	If Not FileExists(@StartupDir & '\SpaceBar.lnk') Then
		FileCreateShortcut(@AutoItExe, @StartupDir & '\SpaceBar.lnk', '', 'SpaceBar')
	EndIf
Else
	FileDelete(@StartupDir & '\SpaceBar.lnk')
EndIf
Global $cGUIColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cGUIColor', 0x444444)
Global $cBarColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cBarColor', 0xBBBBBB)
Global $cGBColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cGBColor', 0xBBBBBB)
Global $cTextColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cTextColor', 0xBBBBBB)
Global $cTextBGColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cTextBGColor', 0x444444)
Global $cWarnColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cWarnColor', 0xDD0000)
Global $cAttentionColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cAttentionColor', 0xEE8800)
Global $cOKColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cOKColor', 0x00CC00)
Global $cCloseBGColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cCloseBGColor', 0xDD0000)
Global $cCloseXColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cCloseXColor', 0xFFFFFF)
Global $cProgressFrontColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cProgressFrontColor', 0xAAAA00)
Global $cProgressFrontGradColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cProgressFrontGradColor', 0xFF0000)
Global $cProgressBGColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cProgressBGColor', 0x00CC00)
Global $cProgressBGEndColor = IniRead(@ScriptDir & '\SpaceBar.ini', 'Color', 'cProgressBGEndColor', 0x00FF00)

Global $iTransparency = IniRead(@ScriptDir & '\SpaceBar.ini', 'Pos', 'iTransparency', 255)

Global $hidden = $bHide, $icon, $msg = 0, $aVol = 0, $cPFC, $cPFGC, $aPos, $iNumCD = 0, $Profiles
Global $aProgress[$aFDrive[0]], $aName[$aFDrive[0]], $aProzent[$aFDrive[0]]
Global $aCMicon[$aFDrive[0]], $aCM1icon[$aFDrive[0]], $aCM2icon[$aFDrive[0]], $aCMNicon[$aFDrive[0]], $aIconH[$aFDrive[0]]
Global $aGB[$aFDrive[0]], $aBuffer[$aFDrive[0]], $aIcon[$aFDrive[0]], $aLWo[$aFDrive[0]], $aLWc[$aFDrive[0]], $aLWname[$aFDrive[0]]
Global $GUICtrlbegin, $GUICtrlend, $Colors

For $i = 0 To $aFDrive[0] - 1
	$aBuffer[$i] = -1; ist notwendig, damit der Text auch bei CDROMs angezeigt wird (CDROM = 0% frei)
Next
Global $aBuffer2[$aFDrive[0]]

Global $iGuiPosX1 = @DesktopWidth - 7; Fenster eingefahren
Global $iGuiPosX2 = @DesktopWidth - 392; Fenster ausgefahren
;--------------------------------------------------------------------------------------------------

Global $gui = GUICreate($title, 390, 8 + $aFDrive[0] * 50, $iGuiPosX1, $iPosY, $WS_POPUP + $WS_BORDER, $WS_EX_TOOLWINDOW)
GUISetBkColor($cGUIColor); Hintergrundfarbe des Fensters
WinSetOnTop($gui, '', $bOnTop)
HotKeySet('!s', '_HideShow'); Hotkey (ALT + s) zum Anzeigen/Verstecken des Fensters
;GUICtrlCreatePic(@ScriptDir & '\bg.png',0,0,500,500)
Global $hider = GUICtrlCreateLabel(_StringRepeat(':: ', $aFDrive[0] * 4), 0, 0, 6, 10 + $aFDrive[0] * 50)
GUICtrlSetBkColor(-1, $cBarColor); Hintergrundfarbe der Seiten-Leiste
GUICtrlSetOnEvent(-1, '_hider')
; Begin Contextmenu
Global $aContext = GUICtrlCreateLabel('  ', 8, 0, 382, 8 + $aFDrive[0] * 50, -1, $GUI_WS_EX_PARENTDRAG);Label for ContextMenu over the other Labels
GUICtrlSetState(-1, $GUI_ONTOP)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
Global $trackmenu = GUICtrlCreateContextMenu($aContext)
Global $aboutitem = GUICtrlCreateMenuItem('ber...', $trackmenu)
GUICtrlSetOnEvent(-1, '_about')
Global $optitem = GUICtrlCreateMenuItem('Optionen...', $trackmenu)
GUICtrlSetOnEvent(-1, '_OptionGUI')
Global $refreshitem = GUICtrlCreateMenuItem('Laufwerke neu einlesen', $trackmenu)
GUICtrlSetOnEvent(-1, '_UpdateRefresh')
Global $netadd = GUICtrlCreateMenuItem('Netzlaufwerk verbinden...', $trackmenu)
GUICtrlSetOnEvent(-1, '_AddNetworkDrive')
GUICtrlCreateMenuItem('', $trackmenu)
Global $ontopitem = GUICtrlCreateMenuItem('Immer im Vordergrund', $trackmenu)
If $bOnTop Then GUICtrlSetState($ontopitem, $GUI_CHECKED)
GUICtrlSetOnEvent(-1, '_OnTop')
Global $exititem = GUICtrlCreateMenuItem('Exit', $trackmenu)
GUICtrlSetOnEvent(-1, '_end')
Global $aExit = GUICtrlCreateIcon('shell32.dll', -132, 373, 0, 17, 17) ; Icon als Exit-Button
If @Compiled Then
	GUICtrlSetImage(-1, @ScriptFullPath, -4)
Else
	If FileExists(@ScriptDir & "\close.ico") Then GUICtrlSetImage(-1, 'close.ico')
EndIf
GUICtrlSetOnEvent(-1, '_end')
GUICtrlSetState(-1, $GUI_ONTOP)
;GUIRegisterMsg($WM_RBUTTONDOWN, '_RightClick')    ; Funktion, um das KontextMenu des Labels auch von der Gui aus aufzurufen
;GUIRegisterMsg($WM_CONTEXTMENU, '_RightClick')    ; Funktion, um das KontextMenu des Labels auch von der Gui aus aufzurufen
GUIRegisterMsg($WM_EXITSIZEMOVE, 'On_WM_EXITSIZEMOVE')    ; Funktion, um die Info GUI am Ende des Drag-Vorgangs wieder an die GUI anzuschlieen.
GUIRegisterMsg($WM_LBUTTONDOWN, '_WinMove')    ; Funktion, um das Fenster zu bewegen
GUIRegisterMsg($WM_ENTERSIZEMOVE, 'On_WM_ENTERSIZEMOVE') ; Docking
GUIRegisterMsg($WM_MOVING, 'On_WM_MOVING')    ; Docking
_CreateDrives()

; Create Info-Window
Global $aIG[8][2]
Global $InfoGui = GUICreate('InfoGui', 400, 300, $iGuiPosX2, $iPosY, $WS_POPUP + $WS_BORDER, $WS_EX_TOOLWINDOW)
GUISetBkColor($cGUIColor)
GUICtrlCreateLabel(_StringRepeat(':: ', 25), 0, 0, 6, 300)
GUICtrlSetBkColor(-1, $cBarColor); Hintergrundfarbe der Seiten-Leiste
GUICtrlSetOnEvent(-1, '_InfoGuiClose')
GUICtrlCreateLabel('Datentrger-Informationen', 30, 10, 300, 30)
GUICtrlSetFont(-1, 18, 800, 0, 'Times New Roman')
GUICtrlSetColor(-1, $cTextColor)
For $j = 0 To 7
	$aIG[$j][0] = GUICtrlCreateLabel('', 15, 50 + $j * 30, 93, 16)
	GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
	GUICtrlSetColor(-1, $cTextColor)
	GUICtrlCreateLabel('=', 105, 50 + $j * 30, 10, 16)
	GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
	GUICtrlSetColor(-1, $cTextColor)
	$aIG[$j][1] = GUICtrlCreateLabel('', 120, 48 + $j * 30, 275, 20)
	GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
	GUICtrlSetColor(-1, $cTextColor)
Next

; Create AddNetworkDrive-Window
Global $ANGui = GUICreate($title & ' - Netzlaufwerk verbinden', 420, 380, -1, -1)
GUICtrlCreateLabel('Profil auswhlen:', 20, 23, 140, 20)
GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
Global $ANProfile = GUICtrlCreateCombo('', 165, 20, 235, 20, $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
Global $ANSave = GUICtrlCreateButton('Speichern', 250, 50, 70, 20)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
Global $ANDel = GUICtrlCreateButton('Lschen', 330, 50, 70, 20)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlCreateLabel('Netzwerkpfad eingeben:', 20, 80, 380, 20)
GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
Global $ANPfad = GUICtrlCreateInput('', 20, 100, 380, 20)
GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
GUICtrlCreateLabel('Beispiel: \\192.168.1.254\freigabeordner', 20, 123, 380, 20)
GUICtrlSetFont(-1, 9, 400, 0, 'Tahoma')
GUICtrlCreateLabel('Laufwerksbuchstaben aussuchen:', 20, 160, 240, 20)
GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
Global $ANLetter = GUICtrlCreateCombo('', 270, 156, 50, 25, $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
GUICtrlCreateLabel('Benutzername:', 20, 200, 380, 20)
GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
Global $ANUser = GUICtrlCreateInput('', 20, 220, 380, 20)
GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
GUICtrlCreateLabel('Passwort:', 20, 260, 380, 20)
GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma')
Global $ANPass = GUICtrlCreateInput('', 20, 280, 380, 20, BitOr($ES_LEFT, $ES_AUTOHSCROLL, $ES_PASSWORD))
GUICtrlSetFont(-1, 10, 400, 0, 'Tahoma')
Global $ANConnect = GUICtrlCreateButton('Verbinden', 20, 320, 90, 24)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
Global $ANCancel = GUICtrlCreateButton('Abbrechen', 310, 320, 90, 24)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')

_Update()

AdlibEnable('_Update', 5000) ; Empfehlung AdlibEnable('_Update', 5000) = 5sek
WinSetTrans($gui, "", $iTransparency)
GUISetState(@SW_SHOW, $gui)

If Not $bHide Then
	For $i = $iGuiPosX1 To $iGuiPosX2 Step - 1
		WinMove($gui, '', $i, Default)
	Next
	WinMove($gui, '', $iGuiPosX2, Default)
EndIf

While 1
	Sleep(20)
WEnd
;--------------------------------------------------------------------------------------------------


;--------------------------------------------------------------------------------------------------
#region Commands ;GUI-Kommandos
Func _about()
	MsgBox(64, 'SpaceBar', $title & '   vom: 20.01.2008 ' & @CRLF & '' & @CRLF & 'In Zusammenarbeit mit: ' & @CRLF & 'Ritzelrocker04, Oscar, Xenobiologist, ' & @CRLF & 'Peethebee und Prog@ndy ' & @CRLF & 'Thx an das www.Autoit.de Team ')
EndFunc   ;==>_about

;Hotkey-Func
Func _HideShow()
	Local $show = True
	If (Not $hidden) And Not WinActive($gui) And Not $bOnTop Then $show = False
	WinActivate($gui)
	If $show Then ControlClick($gui, '', $hider)
EndFunc   ;==>_HideShow

Func _hider()
	If $hidden Then
		_Update(); Werte aktualisieren
		AdlibEnable('_Update', 5000); automatische Aktualisierung einschalten (Fenster ist zu sehen)
		For $i = $iGuiPosX1 To $iGuiPosX2 Step - 35
			WinMove($gui, '', $i, Default)
			Sleep(10)
		Next
		WinMove($gui, '', $iGuiPosX2, Default)
	Else
		_InfoGuiClose()
		Local $pos = WinGetPos($gui)
		If Not ($pos[0] >= $iGuiPosX2 - 20) Then Return
		AdlibDisable(); automatische Aktualisierung ausschalten (Fenster ist versteckt)
		For $i = $iGuiPosX2 To $iGuiPosX1 Step 7
			WinMove($gui, '', $i, Default)
			Sleep(10)
		Next
		WinMove($gui, '', $iGuiPosX1, Default)
	EndIf
	$hidden = Not $hidden
EndFunc   ;==>_hider

Func _OnTop()
	$bOnTop = Not $bOnTop
	WinSetOnTop($gui, '', $bOnTop)
	Switch $bOnTop
		Case True
			GUICtrlSetState($ontopitem, $GUI_CHECKED)
		Case False
			GUICtrlSetState($ontopitem, $GUI_UNCHECKED)
	EndSwitch
EndFunc   ;==>_OnTop

Func _end()
	$aPos = WinGetPos($gui)
	IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'iPosY', $aPos[1])
	IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'bOnTop', $bOnTop)
	;IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'bRefresh', False)
	HotKeySet('#s')
	Exit
EndFunc   ;==>_end

Func _Neustart()
	$aPos = WinGetPos($gui)
	IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'iPosY', $aPos[1])
	IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'bOnTop', $bOnTop)
	HotKeySet('#s')
	If @Compiled Then
		Run(@AutoItExe)
	Else
		Run('"' & @AutoItExe & '" /ErrorStdOut "' & @ScriptFullPath & '"')
	EndIf
	Exit
EndFunc   ;==>_Neustart

Func _UpdateRefresh()
	_Refresh(1)
EndFunc   ;==>_UpdateRefresh

Func _DTInfo()
	Local $msg = @GUI_CtrlId, $info = '', $sDSt, $sDGT, $SlideDirection
	For $i = 0 To $aFDrive[0] - 1
		If $msg = $aCM1icon[$i] Then
			Switch DriveStatus($aCMNicon[$i])
				Case 'UNKNOWN'
					$sDSt = 'Unbekannt'
				Case 'READY'
					$sDSt = 'Bereit'
				Case 'NOTREADY'
					$sDSt = 'Kein Datentrger'
				Case 'INVALID'
					$sDSt = 'Ungltig'
			EndSwitch
			Switch DriveGetType($aCMNicon[$i])
				Case 'Unknown'
					$sDGT = 'Unbekannt'
				Case 'Removable'
					$sDGT = 'Wechseldatentrger'
				Case 'Fixed'
					If _CheckIfUSB($aCMNicon[$i]) Then
						$sDGT = 'USB-Festplatte'
					Else
						$sDGT = 'Festplatte'
					EndIf
				Case 'Network'
					$sDGT = 'Netzwerk'
				Case 'CDROM'
					If _CheckWriter($aCMNicon[$i]) Then
						$sDGT = 'CD-/DVD-Brenner'
					Else
						$sDGT = 'CD-/DVD-Laufwerk'
					EndIf
				Case 'RAMDisk'
					$sDGT = 'RAM-Disk'
			EndSwitch
			Local $aDTBez[8] = ['Buchstabe', 'Bezeichnung', 'Seriennummer', 'Status', 'Dateisystem', 'Clustergre', 'Laufwerkstyp', 'Gertename']
			Local $aDTInfo[8] = [StringUpper($aCMNicon[$i]), DriveGetLabel($aCMNicon[$i]), DriveGetSerial($aCMNicon[$i]), $sDSt, DriveGetFileSystem($aCMNicon[$i]), _ClusterSize($aCMNicon[$i]) & ' Byte', $sDGT, _DriveletterToName($aCMNicon[$i])]
			For $j = 0 To 7
				GUICtrlSetData($aIG[$j][0], $aDTBez[$j])
				GUICtrlSetData($aIG[$j][1], $aDTInfo[$j])
			Next
			ExitLoop
		EndIf
	Next
	Local $pos = WinGetPos($gui)
	If $pos[0] < 400 Then
		$pos[0] += (402 + 392)
		$SlideDirection = $AW_SLIDE_IN_LEFT
	Else
		$SlideDirection = $AW_SLIDE_IN_RIGHT
	EndIf
	If Not BitAND(WinGetState($InfoGui), 2) Then
		WinSetOnTop($InfoGui, '', 0)
		WinMove($InfoGui, '', $pos[0] - 402, $pos[1])
		If Not _WinAnimate($InfoGui, $SlideDirection, 400) Then
			WinMove($InfoGui, '', $iGuiPosX2, $pos[1])
			GUISetState(@SW_SHOW, $InfoGui)
			For $i = $iGuiPosX2 To $iGuiPosX2 - 402 Step - 2
				WinMove($InfoGui, '', $i, $pos[1])
			Next
		EndIf
		GUISetState(@SW_SHOW, $InfoGui)
		WinMove($InfoGui, '', $pos[0] - 402, $pos[1])
		WinSetOnTop($InfoGui, '', 1)
	Else
		WinMove($InfoGui, '', $pos[0] - 402, $pos[1])
	EndIf
EndFunc   ;==>_DTInfo

Func _InfoGuiClose()
	If Not _WinAnimate($InfoGui, $SlideOUTDirection, 600) Then
		Local $pos = WinGetPos($gui)
		WinSetOnTop($InfoGui, '', 0)
		For $i = $iGuiPosX2 - 402 To $iGuiPosX2 Step 1
			WinMove($InfoGui, '', $i, $pos[1])
		Next
		WinMove($InfoGui, '', $iGuiPosX2, $pos[1])
	EndIf
	GUISetState(@SW_HIDE, $InfoGui)
EndFunc   ;==>_InfoGuiClose

Func _EjectMedia()
	Local $msg = @GUI_CtrlId, $rc
	For $i = 0 To $aFDrive[0] - 1
		If $msg = $aCM2icon[$i] Then
			If FileExists(@ScriptDir & '\EjectMedia\EjectMedia.exe') Then
				$rc = _RunDOS(Chr(34) & @ScriptDir & '\EjectMedia\EjectMedia.exe' & Chr(34) & ' ' & $aCMNicon[$i])
				If $rc = 0 Then
					SplashTextOn('SpaceBar', @CRLF & '   Sie knnen den Datentrger jetzt entfernen!', 280, 50, @DesktopWidth - 670, MouseGetPos(1) - 50, 7, 'Arial', 10, 400)
					Sleep(3000)
					SplashOff()
				Else
					SplashTextOn('SpaceBar', @CRLF & '   Datentrger konnte nicht abgemeldet werden!', 280, 50, @DesktopWidth - 670, MouseGetPos(1) - 50, 7, 'Arial', 10, 400)
					Sleep(3000)
					SplashOff()
				EndIf
			Else
				MsgBox(48, 'SpaceBar', 'EjectMedia.exe konnte nicht gefunden werden!')
			EndIf
			ExitLoop
		EndIf
	Next
EndFunc   ;==>_EjectMedia

Func _RemoveDrive()
	Local $msg = @GUI_CtrlId, $rc
	For $i = 0 To $aFDrive[0] - 1
		If $msg = $aCM2icon[$i] Then
			If FileExists(@ScriptDir & '\RemoveDrive\RemoveDrive.exe') Then
				$rc = _RunDOS(Chr(34) & @ScriptDir & '\RemoveDrive\RemoveDrive.exe' & Chr(34) & ' ' & $aCMNicon[$i])
				If $rc = 0 Then
					SplashTextOn('SpaceBar', @CRLF & '   Sie knnen den Datentrger jetzt entfernen!', 280, 50, @DesktopWidth - 670, MouseGetPos(1) - 50, 7, 'Arial', 10, 400)
					Sleep(3000)
					SplashOff()
				Else
					SplashTextOn('SpaceBar', @CRLF & '   Datentrger konnte nicht abgemeldet werden!', 280, 50, @DesktopWidth - 670, MouseGetPos(1) - 50, 7, 'Arial', 10, 400)
					Sleep(3000)
					SplashOff()
				EndIf
			Else
				MsgBox(48, 'SpaceBar', 'RemoveDrive.exe konnte nicht gefunden werden!')
			EndIf
			ExitLoop
		EndIf
	Next
EndFunc   ;==>_RemoveDrive

Func _Explore()
	Local $msg = @GUI_CtrlId
	For $i = 0 To UBound($aIcon) - 1
		If $msg = $aIcon[$i] Then
			Run("explorer.exe /e," & $aFDrive[$i + 1])
			ExitLoop
		EndIf
	Next
EndFunc   ;==>_Explore

Func _LWopenclose()
	Local $msg = @GUI_CtrlId
	For $i = 0 To $iNumCD - 1
		If $msg = $aLWo[$i] Then
			CDTray($aLWname[$i], 'open')
			ExitLoop
		EndIf
		If $msg = $aLWc[$i] Then
			CDTray($aLWname[$i], 'closed')
			ExitLoop
		EndIf
	Next
EndFunc   ;==>_LWopenclose
#endregion
;-------------------------------------------------------------------

;-------------------------------------------------------------------
#region Update+Refresh ;Update+Refresh
Func _Update()
	Local $h = '', $aAllDrive = DriveGetDrive('ALL')
	For $i = 1 To $aAllDrive[0]
		If ($aAllDrive[$i] <> 'a:') And ($aAllDrive[$i] <> 'b:') Then $h &= DriveStatus($aAllDrive[$i])
	Next
	If $h <> $iDrive Then
		_Refresh()
		IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'iDrive', $h)
		$iDrive = $h
	EndIf
	For $i = 0 To $aFDrive[0] - 1
		$aVol = _DriveFree($aFDrive[$i + 1])
		If $aVol[2] = 0 Then $aVol[0] = 100
		If ($aBuffer[$i] = $aVol[2]) And ($aBuffer2[$i] = $aVol[3]) Then ContinueLoop
		$aBuffer[$i] = $aVol[2]
		$aBuffer2[$i] = $aVol[3]
		If $aVol[3] / 1024 < 20.9 Then
			Select
				Case $aVol[0] >= 60
					GUICtrlSetColor($aProzent[$i], $cWarnColor)
				Case $aVol[0] < 60 And $aVol[0] > 40
					GUICtrlSetColor($aProzent[$i], $cAttentionColor)
				Case $aVol[0] <= 40
					GUICtrlSetColor($aProzent[$i], $cOKColor)
			EndSelect
		Else
			Select
				Case Round(Number($aVol[2]) / 1024) < 5
					GUICtrlSetColor($aProzent[$i], $cWarnColor)
				Case Round(Number($aVol[2]) / 1024) <= 10
					GUICtrlSetColor($aProzent[$i], $cAttentionColor)
				Case Else
					GUICtrlSetColor($aProzent[$i], $cOKColor)
			EndSelect
		EndIf
		;_ProgressSet($aProgress[$i], 100-Number($aVol[0]))      ;100% = alles frei
		_ProgressSet($aProgress[$i], Number($aVol[0]))      ;100% = alles voll
		If @error Then MsgBox(0, $aVol[0], @error)
		If DriveGetType($aFDrive[$i + 1]) = 'CDROM'  Then
			If DriveStatus($aFDrive[$i + 1]) = 'READY'  Then
				GUICtrlSetData($aName[$i], $aVol[1] & ' =  ' & _StringAddComma(StringReplace(Round($aVol[3], 2), '.', ','), '.', ',') & ' MB')
			Else
				GUICtrlSetData($aName[$i], $aVol[1] & ' =  Kein Datentrger eingelegt')
			EndIf
		Else
			GUICtrlSetData($aName[$i], 'Auf ' & $aVol[1] & ' sind ' & _StringAddComma(StringReplace($aVol[2], '.', ','), '.', ',') & ' MB frei')
			GUICtrlSetData($aProzent[$i], StringReplace(Round(100 - $aVol[0] + 0.0001, 2), '.', ',') & '% frei')
			GUICtrlSetData($aGB[$i], 'von ' & StringReplace(Round(($aVol[3] / 1024), 1), '.', ',') & ' GB')
		EndIf
	Next
EndFunc   ;==>_Update


; Author: Prog@ndy
Func _Refresh($update = 0)
	GUISetState(@SW_LOCK, $gui)
	For $i = $GUICtrlbegin To $GUICtrlend
		GUICtrlDelete($i)
	Next
	;Sleep(100)
	ReDim $aFDrive[1]
	$aFDrive[0] = 0
	$iNumCD = 0
	$aRemDrive = 0
	_GetDrives()
	Global $aProgress[$aFDrive[0]], $aName[$aFDrive[0]], $aProzent[$aFDrive[0]]
	Global $aGB[$aFDrive[0]], $aIcon[$aFDrive[0]], $aLWo[$aFDrive[0]], $aLWc[$aFDrive[0]], $aLWname[$aFDrive[0]]
	Global $aBuffer[$aFDrive[0]], $aBuffer2[$aFDrive[0]]
	Global $aCMicon[$aFDrive[0]], $aCM1icon[$aFDrive[0]], $aCM2icon[$aFDrive[0]], $aCMNicon[$aFDrive[0]], $aIconH[$aFDrive[0]]
	$aAllDrives = DriveGetDrive('ALL')
	Global $aDriveletter[$aAllDrives[0]][$aAllDrives[0]], $aDeviceName[$aAllDrives[0]], $aCDLN[$aAllDrives[0]][2], $aNtLN[$aAllDrives[0]][2], $aInterface[$aAllDrives[0]]
	_CDROMDrive()
	_DiskDrive()
	_LogicalDiskToPartition()
	$hider = GUICtrlCreateLabel(_StringRepeat(':: ', $aFDrive[0] * 4), 0, 0, 6, 10 + $aFDrive[0] * 50)
	GUICtrlSetBkColor(-1, $cBarColor); Hintergrundfarbe der Seiten-Leiste
	GUICtrlSetOnEvent(-1, '_hider')
	For $i = 0 To $aFDrive[0] - 1
		$aBuffer[$i] = -1; ist notwendig, damit der Text auch bei CDROMs angezeigt wird (CDROM = 0% frei)
		$aBuffer2[$i] = -1
	Next
	WinMove($gui, "", Default, Default, Default, 8 + $aFDrive[0] * 50)
	_CreateDrives()
	If $update Then _Update()
	GUISetState(@SW_UNLOCK, $gui)
EndFunc   ;==>_Refresh

#endregion
;-------------------------------------------------------------------

;-------------------------------------------------------------------
#region DriveFuncs ;DriveFuncs

Func _GetDrives()
	If $bFIXED Then $aFDrive = _getDrivesHelper('FIXED')
	If $bNETWORK Then $aFDrive = _getDrivesHelper('NETWORK')
	If $bREMOVABLE Then $aFDrive = _getDrivesHelper('REMOVABLE')
	If $bCDROM Then $aFDrive = _getDrivesHelper('CDROM')
	If $bRAMDISK Then $aFDrive = _getDrivesHelper('RAMDISK')
	$aFDrive[0] = UBound($aFDrive) - 1
EndFunc   ;==>_GetDrives

Func _getDrivesHelper($type)
	Local $aNDrive = DriveGetDrive($type)
	If IsArray($aNDrive) Then
		For $i = 1 To $aNDrive[0]
			If ($aNDrive[$i] = 'a:') Or ($aNDrive[$i] = 'b:') Then ContinueLoop
			_ArrayAdd($aFDrive, $aNDrive[$i])
		Next
	EndIf
	Return $aFDrive
EndFunc   ;==>_getDrivesHelper

Func _CreateDrives()
	Local $k = 0, $writer, $checkDGT
	$Colors = _Gradient($cProgressBGColor, $cProgressBGEndColor, $aFDrive[0] * 2)
	$GUICtrlbegin = GUICtrlCreateDummy()
	For $i = 0 To $aFDrive[0] - 1
		$checkDGT = DriveGetType($aFDrive[$i + 1])
		Switch $checkDGT
			Case 'RAMDisk'
				$icon = -13
				$cPFC = $cProgressFrontColor
				$cPFGC = $cProgressFrontGradColor
			Case 'CDROM'
				$writer = _CheckWriter($aFDrive[$i + 1])
				$icon = -12
				If DriveStatus($aFDrive[$i + 1]) = 'READY'  Then
					$cPFC = 0x555588; 1. Farbe fr CDROM
					$cPFGC = 0x6666CC; 2. Farbe fr CDROM
				Else
					$cPFC = 0xDDDDDD; 1. Farbe fr 'kein Datentrger'
					$cPFGC = 0xEEEEEE; 2. Farbe fr 'kein Datentrger'
				EndIf
			Case 'Removable'
				$icon = -8
				$cPFC = $cProgressFrontColor
				$cPFGC = $cProgressFrontGradColor
			Case 'Fixed'
				$icon = -9
				$cPFC = $cProgressFrontColor
				$cPFGC = $cProgressFrontGradColor
				Local $reg, $j, $tmp, $val = ''
				$reg = RegRead('HKLM\SYSTEM\MountedDevices', '\DosDevices\' & $aFDrive[$i + 1])
				If Not @error Then
					For $j = 1 To StringLen($reg) - 2 Step 2
						$tmp = _HexToString(StringMid($reg, $j, 2))
						If $tmp <> '' Then
							$val &= $tmp
						EndIf
					Next
					If $val = 'TrueCrypt'  Then $icon = -48
				EndIf
			Case 'Network'
				If DriveStatus($aFDrive[$i + 1]) = 'READY'  Then
					$icon = -10
				Else
					$icon = -11
				EndIf
				$cPFC = $cProgressFrontColor
				$cPFGC = $cProgressFrontGradColor
		EndSwitch
		$aIcon[$i] = GUICtrlCreateIcon(@SystemDir & '\shell32.dll', $icon, 12, 2 + $i * 50, 32, 32)
		GUICtrlSetTip(-1, "Explorer auf " & StringUpper($aFDrive[$i + 1]))
		GUICtrlSetCursor(-1, 0)
		GUICtrlSetOnEvent(-1, "_Explore")
		GUICtrlSetState(-1, $GUI_ONTOP)
		If $writer Then
			$aIconH[$i] = GUICtrlCreateIcon(@SystemDir & '\shell32.dll', -147, 34, 26 + $i * 50, 16, 16)
		EndIf
		$aCMNicon[$i] = $aFDrive[$i + 1]
		$aCMicon[$i] = GUICtrlCreateContextMenu($aIcon[$i])
		$aCM1icon[$i] = GUICtrlCreateMenuItem('Datentrger-Informationen', $aCMicon[$i])
		GUICtrlSetOnEvent(-1, "_DTInfo")
		If $checkDGT = 'Removable'  Then
			$aCM2icon[$i] = GUICtrlCreateMenuItem('Datentrger abmelden', $aCMicon[$i])
			GUICtrlSetOnEvent(-1, '_EjectMedia')
		EndIf
		If ($checkDGT = 'FIXED') And (_CheckIfUSB($aFDrive[$i + 1]) = 1) Then
			$aCM2icon[$i] = GUICtrlCreateMenuItem('Datentrger abmelden', $aCMicon[$i])
			GUICtrlSetOnEvent(-1, '_RemoveDrive')
			GUICtrlSetImage($aIcon[$i], @SystemDir & '\shell32.dll', -8)
		EndIf
		If $checkDGT = 'Network' Then
			$aCM2icon[$i] = GUICtrlCreateMenuItem('Netzlaufwerk trennen', $aCMicon[$i])
			GUICtrlSetOnEvent(-1, '_RemoveNetworkDrive')
		EndIf
		$aProgress[$i] = _ProgressCreate(52, 8 + $i * 50, 230, 20, $cPFC, $cPFGC, $Colors[$k], $Colors[$k + 1])
		If $checkDGT = 'CDROM'  Then
			$aLWname[$iNumCD] = $aFDrive[$i + 1]
			$aLWo[$iNumCD] = GUICtrlCreateButton('Open', 295, 8 + $i * 50, 35, 20)
			GUICtrlSetFont(-1, 8, 800, 0, 'Arial')
			GUICtrlSetOnEvent(-1, '_LWopenclose')
			GUICtrlSetState(-1, $GUI_ONTOP)
			$aLWc[$iNumCD] = GUICtrlCreateButton('Close', 335, 8 + $i * 50, 35, 20)
			GUICtrlSetFont(-1, 8, 800, 0, 'Arial')
			GUICtrlSetOnEvent(-1, '_LWopenclose')
			GUICtrlSetState(-1, $GUI_ONTOP)
			$iNumCD += 1
		Else
			$aProzent[$i] = GUICtrlCreateLabel('', 290, 8 + $i * 50, 70, 20, $ES_RIGHT, $GUI_WS_EX_PARENTDRAG)
			GUICtrlSetFont(-1, 9, 700, 0, 'Arial')
			$aGB[$i] = GUICtrlCreateLabel('', 290, 30 + $i * 50, 70, 20, $ES_RIGHT, $GUI_WS_EX_PARENTDRAG)
			GUICtrlSetFont(-1, 8, 800, 0, 'Arial')
			GUICtrlSetColor(-1, $cGBColor); Farbe der GB-Zahl
		EndIf
		$k += 2
		$aName[$i] = GUICtrlCreateLabel('', 52, 30 + $i * 50, 230, 21)
		GUICtrlSetFont(-1, 8, 800, 0, 'Arial')
		GUICtrlSetColor(-1, $cTextColor); Farbe der Beschriftung unter der Progressbar
		GUICtrlSetBkColor(-1, $cTextBGColor); Farbe des Hintergrundes der Beschriftung unter der Progressbar
	Next
	$GUICtrlend = GUICtrlCreateDummy()
EndFunc   ;==>_CreateDrives

Func _ReadProfiles($items)
	$Profiles = ''
	GUICtrlSetData($ANProfile, '')
	For $i = 1 To $items
		$Profiles &= '#' & $i & '= ' & IniRead(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $i, 'Pfad', '') & '|'
	Next
	$Profiles = StringTrimRight($Profiles, 1)
	GUICtrlSetData($ANProfile, $Profiles)
EndFunc

Func _AddNetworkDrive()
	Local $items = IniRead(@ScriptDir & '\SpaceBar.ini', 'Network-Profiles', 'items', 0) ; Anzahl der Profil-Eintrge holen
	GUICtrlSetData($ANPfad, '')
	GUICtrlSetData($ANUser, '')
	GUICtrlSetData($ANPass, '')
	$aAllDrives = DriveGetDrive('ALL')
	If $items > 0 Then _ReadProfiles($items)
	Opt('GUIOnEventMode', 0)
	GUISetState(@SW_SHOW, $ANGui)
	WinSetOnTop($title & ' - Netzlaufwerk verbinden', '', 1)
	GUICtrlSetState($ANPfad, $GUI_FOCUS)
	GUICtrlSetData($ANLetter, '') ; Buchstaben-Combobox leeren
	Local $v, $letters, $msg, $i, $j
	For $i = 67 To 90 ; Buchstaben 'C' bis 'Z' durchgehen
		$v = 0
		For $j = 1 To $aAllDrives[0] ; Alle belegten Buchstaben
			If Chr($i) & ':' = $aAllDrives[$j] Then ; Buchstabe ist nicht frei
				$v = 1 ; dann kennzeichnen
				ExitLoop ; und For $j - Schleife verlassen
			EndIf
		Next
		If $v <> 1 Then ; War der Buchstabe noch frei
			$letters &= Chr($i) & ':|' ; dann in die Liste bernehmen
		EndIf
	Next
	$letters = StringTrimRight($letters, 1) ; den letzten '|' entfernen
	GUICtrlSetData($ANLetter, $letters, StringRight($letters, 2)) ; Buchstabenliste in die Combobox schreiben und den letzten Buchstaben auswhlen
	While 1
		While 2
			$msg = GUIGetMsg()
			Select
				Case ($msg = $ANCancel) Or ($msg = $GUI_EVENT_CLOSE) ; User hat 'Abbrechen' oder 'X' angeklickt 
					Opt('GUIOnEventMode', 1)
					GUISetState(@SW_HIDE, $ANGui)
					Return 0
				Case $msg = $ANProfile ; User hat eines der Profile ausgewhlt
					Local $nr = StringRegExp(GUICtrlRead($ANProfile),'#(.*)=', 3) ; Die Nummer des momentan ausgewhlten Eintrags ermitteln
					GUICtrlSetData($ANPfad, IniRead(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $nr[0], 'Pfad', '\\')) ; Pfad,
					GUICtrlSetData($ANUser, IniRead(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $nr[0], 'User', '')) ; Benutzername
					GUICtrlSetData($ANPass, _StringEncrypt(0, IniRead(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $nr[0], 'Pass', ''), '89dnpbXocx')) ; und Passwort (entschlsseln) aus der Ini-Datei lesen und in die entsprechenden Felder eintragen
				Case $msg = $ANSave ; User hat auf 'Speichern' geklickt
					If GUICtrlRead($ANPfad) <> '' Then
						$items += 1 ; Anzahl der Eintrge um 1 erhhen
						IniWrite(@ScriptDir & '\SpaceBar.ini', 'Network-Profiles', 'items', $items) ; in die Ini-Datei speichern
						IniWrite(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $items, 'Pfad', GUICtrlRead($ANPfad)) ; Pfad,
						IniWrite(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $items, 'User', GUICtrlRead($ANUser)) ; Benutzername
						IniWrite(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $items, 'Pass', _StringEncrypt(1, GUICtrlRead($ANPass), '89dnpbXocx')) ; und Passwort (verschlsseln) in die Ini-Datei speichern
						SplashTextOn('SpaceBar', @CRLF & '  Profil gespeichert!', 200, 50, -1, -1, 1, 'Arial', 10, 400) ; User informieren
						Sleep(1000)
						SplashOff()
						_ReadProfiles($items) ; Profil-Liste neu erstellen
						Local $aPro = StringSplit($Profiles, '|')
						GUICtrlSetData($ANProfile, $aPro[$aPro[0]]) ; und den letzten Eintrag (den gerade gespeicherten) auswhlen
					EndIf
				Case $msg = $ANDel ; User hat auf 'Lschen' geklickt
					If $items > 0 Then ; Wenn min. 1 Profil-Eintrag vorhanden ist, dann...
						Local $nr = StringRegExp(GUICtrlRead($ANProfile),'#(.*)=', 3) ; Die Nummer des momentan ausgewhlten Eintrags ermitteln
						IniDelete(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $nr[0]) ; Den Eintrag aus der Ini-Datei lschen
						If $nr[0] < $items Then ; Wenn der gelschte Eintrag nicht der letzte Eintrag war, dann...
							For $i = $nr[0] To $items-1 ; alle nachfolgenden Eintrge
								IniRenameSection(@ScriptDir & '\SpaceBar.ini', 'Network-Profile' & $i+1, 'Network-Profile' & $i, 1) ; umbenennen
							Next
						EndIf
						$items -= 1 ; Anzahl der Eintrge um 1 verringern
						IniWrite(@ScriptDir & '\SpaceBar.ini', 'Network-Profiles', 'items', $items) ; und in die Ini-Datei speichern
						SplashTextOn('SpaceBar', @CRLF & '  Profil gelscht!', 200, 50, -1, -1, 1, 'Arial', 10, 400) ; User informieren
						Sleep(1000)
						SplashOff()
						_ReadProfiles($items) ; Profil-Liste neu erstellen
					EndIf
				Case $msg = $ANConnect ; User hat auf 'Verbinden' geklickt
					ExitLoop
			EndSelect
		Wend ; While 2
		DriveMapAdd(GUICtrlRead($ANLetter), GUICtrlRead($ANPfad), 1, GUICtrlRead($ANUser), GUICtrlRead($ANPass))
		If Not @error Then
			SplashTextOn('SpaceBar', @CRLF & '  Netzlaufwerk verbunden!', 200, 50, -1, -1, 1, 'Arial', 10, 400)
			Sleep(1000)
			SplashOff()
			Opt('GUIOnEventMode', 1)
			GUISetState(@SW_HIDE, $ANGui)
			Return 1
		Else
			Local $f
			Switch @error
				Case 1
					$f = 'Undefinierter Fehler!'
				Case 2
					$f = 'Der Zugriff auf die Freigabe wurde verweigert!'
				Case 3
					$f = 'Das Netzlaufwerk ist bereits verbunden!'
				Case 4
					$f = 'Ungltiger Laufwerksbuchstabe!'
				Case 5
					$f = 'Ungltige Freigabe!'
				Case 6
					$f = 'Ungltiges Passwort!'
			EndSwitch
			SplashTextOn('SpaceBar', @CRLF & '  Netzlaufwerk konnte nicht verbunden werden!' & @CRLF & @CRLF & $f, 320, 80, -1, -1, 1, 'Arial', 10, 400)
			Sleep(3000)
			SplashOff()
		EndIf
	WEnd ; While 1
EndFunc

Func _RemoveNetworkDrive()
	Local $msg = @GUI_CtrlId, $rc
	For $i = 0 To $aFDrive[0] - 1
		If $msg = $aCM2icon[$i] Then
			$rc = DriveMapDel($aCMNicon[$i])
			If $rc = 1 Then
				SplashTextOn('SpaceBar', @CRLF & '   Netzlaufwerk getrennt!', 200, 50, @DesktopWidth - 590, MouseGetPos(1) - 50, 1, 'Arial', 10, 400)
				Sleep(1000)
				SplashOff()
			Else
				SplashTextOn('SpaceBar', @CRLF & '   Netzlaufwerk konnte nicht getrennt werden!', 280, 50, @DesktopWidth - 670, MouseGetPos(1) - 50, 1, 'Arial', 10, 400)
				Sleep(1000)
				SplashOff()
			EndIf
			ExitLoop
		EndIf
	Next
EndFunc

Func _CheckWriter($drive)
	Local $reg, $k, $tmp, $val = ''
	$reg = RegRead('HKLM\SYSTEM\MountedDevices', '\DosDevices\' & $drive)
	If Not @error Then
		For $k = 1 To StringLen($reg) - 2 Step 2
			$tmp = _HexToString(StringMid($reg, $k, 2))
			If $tmp <> '' Then
				$val &= $tmp
			EndIf
		Next
		$reg = StringSplit($val, '#')
		$reg[1] = StringReplace($reg[1], '\??\', '')
		$tmp = RegRead('HKLM\SYSTEM\CurrentControlSet\Enum\' & $reg[1] & '\' & $reg[2] & '\' & $reg[3], 'LowerFilters')
	EndIf
	If @error Then
		Return 0
	Else
		Return 1
	EndIf
EndFunc   ;==>_CheckWriter

Func _ClusterSize($drive)
	Local $ret = DllCall("kernel32.dll", "int", "GetDiskFreeSpace", _
			"str", $drive & '\', _
			"ptr", DllStructGetPtr($pGDFS, 1), _
			"ptr", DllStructGetPtr($pGDFS, 2), _
			"ptr", DllStructGetPtr($pGDFS, 3), _
			"ptr", DllStructGetPtr($pGDFS, 4))
	Return DllStructGetData($pGDFS, 1) * DllStructGetData($pGDFS, 2)
EndFunc   ;==>_ClusterSize

Func _DriveletterToName($drive)
	Switch DriveGetType($drive)
		Case 'Unknown'
			Return 'Unbekannt'
		Case 'Network'
			Return DriveMapGet($drive)
		Case 'CDROM'
			For $i = 0 To UBound($aCDLN) - 1
				If $drive = $aCDLN[$i][1] Then Return $aCDLN[$i][0]
			Next
			Return 'Unbekannt'
		Case 'RAMDisk'
			Return 'RAM-Disk'
		Case Else
			For $i = 0 To $aFDrive[0] - 1
				For $j = 0 To $aFDrive[0] - 1
					If $drive = $aDriveletter[$i][$j] Then Return $aDeviceName[$i]
				Next
			Next
			Local $reg, $k, $tmp, $val = ''
			$reg = RegRead('HKLM\SYSTEM\MountedDevices', '\DosDevices\' & $drive)
			If Not @error Then
				For $k = 1 To StringLen($reg) - 2 Step 2
					$tmp = _HexToString(StringMid($reg, $k, 2))
					If $tmp <> '' Then
						$val &= $tmp
					EndIf
				Next
				If $val = 'TrueCrypt'  Then
					Local $TCv = FileGetVersion(StringTrimRight(RegRead('HKLM\SOFTWARE\Classes\TrueCryptVolume\DefaultIcon', ''), 2))
					Return 'TrueCrypt - Version: ' & $TCv
				EndIf
			EndIf
			Return 'Unbekannt'
	EndSwitch
EndFunc   ;==>_DriveletterToName

Func _CheckIfUSB($drive)
	For $i = 0 To $aFDrive[0] - 1
		For $j = 0 To $aFDrive[0] - 1
			If $drive = $aDriveletter[$i][$j] Then
				If $aInterface[$i] = 'USB'  Then
					Return 1
				Else
					Return 0
				EndIf
			EndIf
		Next
	Next
EndFunc   ;==>_CheckIfUSB

Func _CDROMDrive()
	Local $count = 0
	Local $colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_CDROMDrive", "WQL", 0x30)
	If IsObj($colItems) Then
		For $objItem In $colItems
			$aCDLN[$count][0] = $objItem.Caption
			$aCDLN[$count][1] = $objItem.Drive
			$count += 1
		Next
	Else
		MsgBox(0, "WMI Output", "No WMI Objects Found for class: " & "Win32_CDROMDrive")
	EndIf
EndFunc   ;==>_CDROMDrive

Func _DiskDrive()
	Local $id
	Local $colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_DiskDrive", "WQL", 0x30)
	If IsObj($colItems) Then
		For $objItem In $colItems
			$id = Number(StringReplace($objItem.DeviceID, '\\.\PHYSICALDRIVE', ''))
			$aDeviceName[$id] = $objItem.Caption
			$aInterface[$id] = $objItem.InterfaceType
		Next
	Else
		MsgBox(0, "WMI Output", "No WMI Objects Found for class: " & "Win32_DiskDrive")
	EndIf
EndFunc   ;==>_DiskDrive

Func _LogicalDiskToPartition()
	Local $disk, $Ant, $Dep, $i   ;, $epart = 0, $part Wird nicht mehr bentigt. Es wird der nchste freie Slot genommen
	Local $colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_LogicalDiskToPartition", "WQL", 0x30)
	If IsObj($colItems) Then
		For $objItem In $colItems
			$Ant = StringRegExp($objItem.Antecedent, '".*"', 1)
			$disk = StringRegExp($Ant[0], 'Disk #(.*),', 1)
			$disk = Number($disk[0])
			;$part = StringRegExp($Ant[0], 'Partition #(.*)"', 1)
			;$part = Number($part[0])
			$Dep = StringRegExp($objItem.Dependent, '".*"', 1)
			For $i = 0 To UBound($aDriveletter,2)
				If ($aDriveletter[$disk][$i] == StringReplace($Dep[0], '"', '')) Or ($aDriveletter[$disk][$i] == "") Then ExitLoop
			Next
			$aDriveletter[$disk][$i] = StringReplace($Dep[0], '"', '')
			;If ($aDriveletter[$disk][$part + $epart] <> StringReplace($Dep[0], '"', '')) And ($aDriveletter[$disk][$part + $epart] <> "") Then $epart += 1
			;$aDriveletter[$disk][$part + $epart] = StringReplace($Dep[0], '"', '')
		Next
		;_ArrayDisplay($aDriveletter)
	Else
		MsgBox(0, "WMI Output", "No WMI Objects Found for class: " & "Win32_LogicalDiskToPartition")
	EndIf
EndFunc   ;==>_LogicalDiskToPartition

Func _DriveFree($LW)
	Local $TOTAL = DriveSpaceTotal($LW), $FREE = DriveSpaceFree($LW), _
			$aDrive[4] = [Round(($TOTAL - $FREE) / ($TOTAL / 100) + 0.0001, 2), _
			StringUpper($LW) & ' (' & DriveGetLabel($LW) & ')', _
			Round($FREE, 2), _
			$TOTAL]
	Return $aDrive
EndFunc   ;==>_DriveFree
#endregion
;-------------------------------------------------------------------

;-------------------------------------------------------------------
;Author: Prog@ndy
Func _OptionGUI()
	Opt('GUIOnEventMode', 0)
	Local $tGUIColor = $cGUIColor, $tBarColor = $cBarColor, $tGBColor = $cGBColor, $tTextColor = $cTextColor, $tTextBGColor = $cTextBGColor, _
			$tWarnColor = $cWarnColor, $tAttentionColor = $cAttentionColor, $tOKColor = $cOKColor, $tCloseBGColor = $cCloseBGColor, _
			$tCloseXColor = $cCloseXColor, $tProgressFrontColor = $cProgressFrontColor, $tProgressFrontGradColor = $cProgressFrontGradColor, _
			$tProgressBGColor = $cProgressBGColor, $tProgressBGEndColor = $cProgressBGEndColor
	#Region ### START Koda GUI section ### Form=D:\Dokumente\Dateien von Andreas\OptGUI.kxf
	Local $OptGUI = GUICreate('SpaceBar Optionen', 316, 441, -1, -1)
	WinSetOnTop($OptGUI, '', 1)
	GUISetIcon(@SystemDir & '\shell32.dll', -58)
	Local $Tab1 = GUICtrlCreateTab(0, 0, 313, 401)
	GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
	Local $tabMisc = GUICtrlCreateTabItem('Optionen')
	Local $chkAutostart = GUICtrlCreateCheckbox('Mit Windows starten', 40, 38, 249, 25)
	If Execute($bAutostart) Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $chkHideOnStart = GUICtrlCreateCheckbox('Versteckt Starten', 40, 68, 249, 25)
	If Execute($bHide) Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $grpDrives = GUICtrlCreateGroup('Laufwerkstypen', 24, 116, 265, 185)
	GUICtrlSetBkColor(-1, 0xFFFBF0)
	Local $chkCDROM = GUICtrlCreateCheckbox('CD- und DVD- Laufwerke', 40, 140, 225, 25)
	If Execute($bCDROM) Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $chkREMOVABLE = GUICtrlCreateCheckbox('Wechseldatentrger', 40, 170, 225, 25)
	If Execute($bREMOVABLE) Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $chkFixed = GUICtrlCreateCheckbox('Festplatten', 40, 200, 225, 25)
	If Execute($bFIXED) Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $chkNETWORK = GUICtrlCreateCheckbox('Netzlaufwerke', 40, 230, 225, 25)
	If Execute($bNETWORK) Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $chkRAMDISK = GUICtrlCreateCheckbox('RamDisks', 40, 260, 225, 25)
	If Execute($bRAMDISK) Then GUICtrlSetState(-1, $GUI_CHECKED)
	GUICtrlCreateGroup('', -99, -99, 1, 1)
	GUICtrlSetTip(-1, 'Laufwerke, die angezeigt werden sollen')
	Local $tabColor = GUICtrlCreateTabItem('Farben')
	GUICtrlSetState(-1, $GUI_SHOW)
	Local $btnGUI = GUICtrlCreateButton('GUI-Hintergrund', 24, 40, 121, 25, 0)
	Local $btnBar = GUICtrlCreateButton('Hide-Bar', 24, 65, 121, 25, 0)
	Local $btnGB = GUICtrlCreateButton('GB-Label', 24, 89, 121, 25, 0)
	Local $btnText = GUICtrlCreateButton('Info-Text', 24, 114, 121, 25, 0)
	Local $btnTextBG = GUICtrlCreateButton('Info-Text Hintergrund', 24, 138, 121, 25, 0)
	Local $btnWarn = GUICtrlCreateButton('Warnfarbe', 24, 163, 121, 25, 0)
	Local $btnAttention = GUICtrlCreateButton('Achtung-Farbe', 24, 188, 121, 25, 0)
	Local $btnOKColor = GUICtrlCreateButton('OK-Farbe', 24, 212, 121, 25, 0)
	Local $btnProgress = GUICtrlCreateButton("Progressbar", 24, 235, 121, 25, 0)
	Local $btnProgressGrad = GUICtrlCreateButton("Progressbar Verlauf", 24, 260, 121, 25, 0)
	Local $btnProgressBG = GUICtrlCreateButton("Progress BG", 24, 286, 121, 25, 0)
	Local $btnProgressBGGrad = GUICtrlCreateButton("Progress BG Verlauf", 24, 311, 121, 25, 0)
	Local $grGUI = GUICtrlCreateLabel('', 168, 43, 65, 19)
	GUICtrlSetBkColor(-1, $cGUIColor)
	Local $grBar = GUICtrlCreateLabel('', 168, 68, 65, 19)
	GUICtrlSetBkColor(-1, $cBarColor)
	Local $grGB = GUICtrlCreateLabel('', 168, 92, 65, 19)
	GUICtrlSetBkColor(-1, $cGBColor)
	Local $grText = GUICtrlCreateLabel('', 168, 117, 65, 19)
	GUICtrlSetBkColor(-1, $cTextColor)
	Local $grTextBG = GUICtrlCreateLabel('', 168, 141, 65, 19)
	GUICtrlSetBkColor(-1, $cTextBGColor)
	Local $grWarn = GUICtrlCreateLabel('', 168, 166, 65, 19)
	GUICtrlSetBkColor(-1, $cWarnColor)
	Local $grAttention = GUICtrlCreateLabel('', 168, 191, 65, 19)
	GUICtrlSetBkColor(-1, $cAttentionColor)
	Local $grOKColor = GUICtrlCreateLabel('', 168, 215, 65, 19)
	GUICtrlSetBkColor(-1, $cOKColor)
	Local $grProgress = GUICtrlCreateLabel('', 168, 239, 65, 19)
	GUICtrlSetBkColor(-1, $cProgressFrontColor)
	Local $grProgressGrad = GUICtrlCreateLabel('', 168, 264, 65, 19)
	GUICtrlSetBkColor(-1, $cProgressFrontGradColor)
	Local $grProgressBG = GUICtrlCreateLabel('', 168, 290, 65, 19)
	GUICtrlSetBkColor(-1, $cProgressBGColor)
	Local $grProgressBGGrad = GUICtrlCreateLabel('', 168, 315, 65, 19)
	GUICtrlSetBkColor(-1, $cProgressBGEndColor)
	Local $lblTrans = GUICtrlCreateLabel("Transparenz: ( 50 - 255 )", 24, 344, 220, 17)
	Local $slTrans = GUICtrlCreateSlider(16, 368, 289, 25)
	GUICtrlSetLimit(-1, 255, 50)
	GUICtrlSetData(-1, $iTransparency)
	GUICtrlCreateTabItem('')
	Local $btnOK = GUICtrlCreateButton('OK', 24, 408, 105, 25, 0)
	Local $btnCancel = GUICtrlCreateButton('Abbrechen', 152, 408, 113, 25, 0)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###
	Local $nMsg
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				GUIDelete($OptGUI)
				ExitLoop
			Case $btnCancel
				GUIDelete($OptGUI)
				WinSetTrans($gui, "", $iTransparency)
				ExitLoop
			Case $btnAttention
				$tAttentionColor = _ChooseColor(2, $tAttentionColor, 2)
				GUICtrlSetBkColor($grAttention, $tAttentionColor)
			Case $btnWarn
				$tWarnColor = _ChooseColor(2, $tWarnColor, 2)
				GUICtrlSetBkColor($grWarn, $tWarnColor)
			Case $btnGUI
				$tGUIColor = _ChooseColor(2, $tGUIColor, 2)
				GUICtrlSetBkColor($grGUI, $tGUIColor)
			Case $btnBar
				$tBarColor = _ChooseColor(2, $tBarColor, 2)
				GUICtrlSetBkColor($grBar, $tBarColor)
			Case $btnGB
				$tGBColor = _ChooseColor(2, $tGBColor, 2)
				GUICtrlSetBkColor($grGB, $tGBColor)
			Case $btnText
				$tTextColor = _ChooseColor(2, $tTextColor, 2)
				GUICtrlSetBkColor($grText, $tTextColor)
			Case $btnTextBG
				$tTextBGColor = _ChooseColor(2, $tTextBGColor, 2)
				GUICtrlSetBkColor($grTextBG, $tTextBGColor)
			Case $btnOKColor
				$tOKColor = _ChooseColor(2, $tOKColor, 2)
				GUICtrlSetBkColor($grOKColor, $tOKColor)
			Case $btnProgress
				$tProgressFrontColor = _ChooseColor(2, $tProgressFrontColor, 2)
				GUICtrlSetBkColor($grProgress, $tProgressFrontColor)
			Case $btnProgressGrad
				$tProgressFrontGradColor = _ChooseColor(2, $tProgressFrontGradColor, 2)
				GUICtrlSetBkColor($grProgressGrad, $tProgressFrontGradColor)
			Case $btnProgressBG
				$tProgressBGColor = _ChooseColor(2, $tProgressBGColor, 2)
				GUICtrlSetBkColor($grProgressBG, $tProgressBGColor)
			Case $btnProgressBGGrad
				$tProgressBGEndColor = _ChooseColor(2, $tProgressBGEndColor, 2)
				GUICtrlSetBkColor($grProgressBGGrad, $tProgressBGEndColor)
			Case $slTrans
				GUICtrlSetData($lblTrans, "Transparenz: (50-255) * Aktuell: " & GUICtrlRead($slTrans))
				WinSetTrans($gui, "", GUICtrlRead($slTrans))
			Case $btnOK
				;$bHide = False
				;If BitAND(GUICtrlRead($chkHideOnStart), $GUI_CHECKED) Then $bHide = True
				If (BitAND(GUICtrlRead($chkAutostart), $GUI_CHECKED)) And (@Compiled = 1) Then
					If Not FileExists(@StartupDir & '\SpaceBar.lnk') Then
						FileCreateShortcut(@AutoItExe, @StartupDir & '\SpaceBar.lnk', '', 'SpaceBar')
					EndIf
				Else
					FileDelete(@StartupDir & '\SpaceBar.lnk')
				EndIf
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'iTransparency', GUICtrlRead($slTrans))
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'bAutostart', BitAND(GUICtrlRead($chkAutostart), $GUI_CHECKED))
				$bREMOVABLE = BitAND(GUICtrlRead($chkREMOVABLE), $GUI_CHECKED)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'REMOVABLE', $bREMOVABLE)
				$bFIXED = BitAND(GUICtrlRead($chkFixed), $GUI_CHECKED)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'FIXED', $bFIXED)
				$bCDROM = BitAND(GUICtrlRead($chkCDROM), $GUI_CHECKED)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'CDROM', $bCDROM)
				$bNETWORK = BitAND(GUICtrlRead($chkNETWORK), $GUI_CHECKED)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'NETWORK', $bNETWORK)
				$bRAMDISK = BitAND(GUICtrlRead($chkRAMDISK), $GUI_CHECKED)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'DriveTypes', 'RAMDISK', $bRAMDISK)
				$bHide = BitAND(GUICtrlRead($chkHideOnStart), $GUI_CHECKED)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'bHide', $bHide)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cGUIColor', $tGUIColor);0x444444)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cBarColor', $tBarColor);0xBBBBBB)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cGBColor', $tGBColor);0xBBBBBB)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cTextColor', $tTextColor);0xBBBBBB)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cTextBGColor', $tTextBGColor);0x666666)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cWarnColor', $tWarnColor);0xDD0000)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cAttentionColor', $tAttentionColor);0xEE8800)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cOKColor', $tOKColor);0x00CC00)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cCloseBGColor', $tCloseBGColor);0xDD0000)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cCloseXColor', $tCloseXColor);0xFFFFFF)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cProgressFrontColor', $tProgressFrontColor);0xAAAA00)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cProgressFrontGradColor', $tProgressFrontGradColor);0xFF0000)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cProgressBGColor', $tProgressBGColor);0x00CC00)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Color', 'cProgressBGEndColor', $tProgressBGEndColor);0x00FF00)
				$aPos = WinGetPos($gui)
				IniWrite(@ScriptDir & '\SpaceBar.ini', 'Pos', 'iPosY', $aPos[1])
				$iPosY = $aPos[1]
				GUIDelete($OptGUI)
				_Neustart()
				ExitLoop
		EndSwitch
	WEnd
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_OptionGUI
;-------------------------------------------------------------------

;-------------------------------------------------------------------
#region Moving and Docking ;Moving and Docking
Func _WinMove($HWnd, $Command, $wParam, $lParam)
	If BitAND(WinGetState($HWnd), 32) Then Return $GUI_RUNDEFMSG
	DllCall('user32.dll', 'long', 'SendMessage', 'hwnd', $HWnd, 'int', $WM_SYSCOMMAND, 'int', 0xF009, 'int', 0)
EndFunc   ;==>_WinMove


Func On_WM_EXITSIZEMOVE()
	Local $pos = WinGetPos($gui)
	If $pos[0] < 400 Then
		$pos[0] += (402 + 392)
		$SlideOUTDirection = $AW_SLIDE_OUT_LEFT
	Else
		$SlideOUTDirection = $AW_SLIDE_OUT_RIGHT
	EndIf
	If BitAND(WinGetState($InfoGui), 2) Then WinMove($InfoGui, '', $pos[0] - 402, $pos[1])
EndFunc   ;==>On_WM_EXITSIZEMOVE

; Author: Xenobiologist (Mega)
Func On_WM_ENTERSIZEMOVE()
	Local $aMPos = MouseGetPos()
	$x_start = $aMPos[0]
	$y_start = $aMPos[1]
EndFunc   ;==>On_WM_ENTERSIZEMOVE

; Author: Xenobiologist (Mega)
Func On_WM_MOVING($HWnd, $msg, $wParam, $lParam)
	Local $aMPos = MouseGetPos()
	Local $rect = DllStructCreate('long left; long top; long right; long bottom', $lParam)
	Local $left = DllStructGetData($rect, 'left')
	Local $top = DllStructGetData($rect, 'top')
	Local $right = DllStructGetData($rect, 'right')
	Local $bottom = DllStructGetData($rect, 'bottom')
	If $left <= $Range And $aMPos[0] < $x_start Then
		DllStructSetData($rect, 'left', 0)
		DllStructSetData($rect, 'right', $right - $left)
	EndIf
	If $top <= $Range And $aMPos[1] < $y_start Then
		DllStructSetData($rect, 'top', 0)
		DllStructSetData($rect, 'bottom', $bottom - $top)
	EndIf
	If $right >= (@DesktopWidth - $Range) And $aMPos[0] > $x_start Then
		DllStructSetData($rect, 'right', @DesktopWidth)
		DllStructSetData($rect, 'left', (@DesktopWidth - $right) + $left)
	EndIf
	If $bottom >= ($taskbarPos[1] - $Range) And $aMPos[1] > $y_start Then
		DllStructSetData($rect, 'bottom', $taskbarPos[1])
		DllStructSetData($rect, 'top', ($taskbarPos[1] - $bottom) + $top)
	EndIf
	On_WM_ENTERSIZEMOVE()
EndFunc   ;==>On_WM_MOVING

Func _WinAnimate($v_gui, $i_mode, $i_duration = 1000)
	If @OSVersion = "WIN_XP"  Or @OSVersion = "WIN_2000"  Then
		DllCall("user32.dll", "int", "AnimateWindow", "hwnd", WinGetHandle($v_gui), "int", $i_duration, "long", $i_mode)
		Local $ai_gle = DllCall('kernel32.dll', 'int', 'GetLastError')
		If $ai_gle[0] <> 0 Then
			SetError(1)
			Return 0
		EndIf
		Return 1
	EndIf
	Return 0
EndFunc   ;==>_WinAnimate

#endregion
;-------------------------------------------------------------------

;-------------------------------------------------------------------
#region Gradient ;Gradient
;===============================================================================
;
; Function Name:   _Gradient($RGB_Color1 ,$RGB_Color2, $Count)
; Description::    Returns an Array of Gradient Colors
; Parameter(s):    $RGB_Color1 : The Start-Color in RGB Hexadecimal
;                  $RGB_Color2 : The End-Color in RGB Hexadecimal
;                  $Count :      The number of Colors in the Gradient
; Requirement(s):
; Return Value(s): An Array with the Colors
; Author(s):       Prog@ndy
;
;===============================================================================
;

Func _Gradient($RGB_Color1, $RGB_Color2, $count)
	Dim $Color1_R, $Color1_G, $Color1_B, $Color2_R, $Color2_G, $Color2_B, $NeuCol_R, $NeuCol_G, $NeuCol_B

	$Color1_R = BitAND(BitShift($RGB_Color1, 16), 0xff)
	$Color1_G = BitAND(BitShift($RGB_Color1, 8), 0xff)
	$Color1_B = BitAND($RGB_Color1, 0xff)

	$Color2_R = BitAND(BitShift($RGB_Color2, 16), 0xff)
	$Color2_G = BitAND(BitShift($RGB_Color2, 8), 0xff)
	$Color2_B = BitAND($RGB_Color2, 0xff)

	$count -= 1 ; 0-basiert !
	Dim $arColors[$count + 1], $pos1

	For $i = 0 To $count
		$pos1 = $count - $i
		$NeuCol_R = ($Color1_R * $pos1 + $Color2_R * $i) / ($count)
		$NeuCol_G = ($Color1_G * $pos1 + $Color2_G * $i) / ($count)
		$NeuCol_B = ($Color1_B * $pos1 + $Color2_B * $i) / ($count)
		$arColors[$i] = Execute('0x' & Hex($NeuCol_R, 2) & Hex($NeuCol_G, 2) & Hex($NeuCol_B, 2))
	Next
	Return $arColors
EndFunc   ;==>_Gradient
#endregion
;-------------------------------------------------------------------

;-------------------------------------------------------------------
#region Colored Progressbar ;Colored Progressbar

;Hilfsfunktion fr doppelten Verlauf
; Author(s):       Prog@ndy
Func _ZwischenGrad($RGB_c)
	Local $c_R = BitAND(BitShift($RGB_c, 16), 0xff)
	Local $c_G = BitAND(BitShift($RGB_c, 8), 0xff)
	Local $c_B = BitAND($RGB_c, 0xff)
	$c_R = _MyMax(0, $c_R - 99)
	$c_G = _MyMax(0, $c_G - 99)
	$c_B = _MyMax(0, $c_B - 99)
	Return Dec(Hex($c_R, 2) & Hex($c_G, 2) & Hex($c_B, 2))
EndFunc   ;==>_ZwischenGrad

; Author(s):       Prog@ndy
Func _ProgressCreate($X, $Y, $w = 204, $h = 24, $Col = 0xFFFF00, $GradCol = 0x00FF00, $BG = 0xAAAA00, $GradBG = 0xFF0000)
	Local $id[8]
	$id[0] = GUICtrlCreateGraphic($X, $Y, $w, $h)
	Local $error = @error
	Local $extended = @extended
	$id[1] = $w
	$id[2] = $h
	If $Col = -1 Then $Col = 0xFFFF00
	If $BG = -1 Then $BG = 0xAAAA00
	If $GradCol = -1 Then $GradCol = 0x00FF00
	If $GradBG = -1 Then $GradBG = 0xFF0000
	$id[3] = $Col
	$id[4] = $BG
	$id[5] = $GradCol
	$id[6] = $GradBG
	_ProgressSet($id, 0)
	Return SetError($error, $extended, $id)
EndFunc   ;==>_ProgressCreate

; Author(s):       Prog@ndy
Func _ProgressDelete(ByRef $id)
	If Not IsArray($id) Or UBound($id) <> 8 Then Return SetError(1, 0, 0)
	$id[1] = -1
	$id[2] = -1
	$id[3] = -1
	$id[4] = -1
	$id[5] = -1
	$id[6] = -1
	$id[7] = -1
	Dim $temp = GUICtrlDelete($id[0])
	Return SetError(@error, 0, $temp)
EndFunc   ;==>_ProgressDelete

; Author(s):       Prog@ndy
Func _ProgressSetColors(ByRef $id, $Col, $BG = -1, $GradCol = -1, $GradBG = -1)
	If Not IsArray($id) Or UBound($id) <> 8 Then Return SetError(1, 0, 0)
	$id[3] = $Col
	If $BG <> -1 Then $id[4] = $BG
	If $GradCol <> -1 Then $id[5] = $GradCol
	If $GradBG <> -1 Then $id[6] = $GradBG
	MsgBox(0, $id[6], $id[7])
	_ProgressSet($id, $id[7])
	Return SetError(@error, 0, @error)
EndFunc   ;==>_ProgressSetColors

; Author(s):       Prog@ndy
Func _ProgressSet(ByRef $id, $value)
	Local $Wechsel = Round((9 / 20) * $id[2] - 4)
	Local $Hoehe = $id[2] - 4
	Local $Breite = $id[1] - 4
	If $value <= $id[7] Then
		GUICtrlSetBkColor($id[0], 0xAAAAAA)
		GUICtrlSetColor($id[0], 0x777777)
		$id[7] = $value
		Local $temp = _ZwischenGrad($id[6])
		Local $Gradient = _Gradient($id[4], $temp, $Wechsel)
		Local $Gradient2 = _Gradient($temp, $id[6], $Hoehe - $Wechsel)
		For $i = 2 To $Wechsel + 1
			GUICtrlSetGraphic($id[0], $GUI_GR_COLOR, $Gradient[$i - 2])
			GUICtrlSetGraphic($id[0], $GUI_GR_RECT, 2, $i, $Breite, 1)
		Next
		For $i = $Wechsel + 2 To $Hoehe + 1
			GUICtrlSetGraphic($id[0], $GUI_GR_COLOR, $Gradient2[$i - $Wechsel - 2])
			GUICtrlSetGraphic($id[0], $GUI_GR_RECT, 2, $i, $Breite, 1)
		Next
		Local $start = 2
	Else
		Local $start = $id[7] + 2
		$id[7] = $value
	EndIf

	Local $Faktor = $Breite / 100
	$value *= $Faktor
	If Round($value) >= $Breite Then $value = $Breite
	Local $temp = _ZwischenGrad($id[5])
	Local $Gradient = _Gradient($id[3], $temp, $Wechsel)
	Local $Gradient2 = _Gradient($temp, $id[5], $Hoehe - $Wechsel)
	;Local $Gradient = _Gradient(0xFFFF00,0x00AA00, $Wechsel)
	;Local $Gradient2 = _Gradient(0x00AA00,0x00FF00, $Hoehe-$Wechsel)
	For $i = 2 To $Wechsel + 1
		GUICtrlSetGraphic($id[0], $GUI_GR_COLOR, $Gradient[$i - 2])
		GUICtrlSetGraphic($id[0], $GUI_GR_RECT, $start, $i, $value - $start + 2, 1)
	Next
	For $i = $Wechsel + 2 To $Hoehe + 1
		GUICtrlSetGraphic($id[0], $GUI_GR_COLOR, $Gradient2[$i - $Wechsel - 2])
		GUICtrlSetGraphic($id[0], $GUI_GR_RECT, $start, $i, $value - $start + 2, 1)
	Next

	GUICtrlSetGraphic($id[0], $GUI_GR_COLOR, 0xCCCCCC)
	GUICtrlSetGraphic($id[0], $GUI_GR_PIXEL, 2, 2)
	GUICtrlSetGraphic($id[0], $GUI_GR_PIXEL, 2, $Hoehe + 1);19)
	GUICtrlSetGraphic($id[0], $GUI_GR_PIXEL, $Breite + 1, 2)
	GUICtrlSetGraphic($id[0], $GUI_GR_PIXEL, $Breite + 1, $Hoehe + 1)
	GUICtrlSetGraphic($id[0], $GUI_GR_COLOR, $cGUIColor)
	GUICtrlSetGraphic($id[0], $GUI_GR_PIXEL, 0, $Hoehe + 3)
	GUICtrlSetGraphic($id[0], $GUI_GR_PIXEL, 0, 0)
	GUICtrlSetGraphic($id[0], $GUI_GR_PIXEL, $Breite + 3, $Hoehe + 3)
	GUICtrlSetGraphic($id[0], $GUI_GR_PIXEL, $Breite + 3, 0)

	GUICtrlSetGraphic($id[0], $GUI_GR_REFRESH)

EndFunc   ;==>_ProgressSet

; Original _Max() Function, directly included
; Author(s):       Jeremy Landes <jlandes at landeserve dot com>
Func _MyMax($nNum1, $nNum2)
	; Check to see if the parameters are indeed numbers of some sort.
	If (Not IsNumber($nNum1)) Then
		SetError(1)
		Return (0)
	EndIf
	If (Not IsNumber($nNum2)) Then
		SetError(2)
		Return (0)
	EndIf

	If $nNum1 > $nNum2 Then
		Return $nNum1
	Else
		Return $nNum2
	EndIf
EndFunc   ;==>_MyMax

#endregion
;-------------------------------------------------------------------

#cs Werden zur Zeit nicht verwendet
;-------------------------------------------------------------------
#region  ;Context Menu Handlers
Func _RightClick($HWnd, $Command, $wParam, $lParam)
	;MsgBox(0, '', @GUI_CtrlId)
	If @GUI_WinHandle = $gui Then ShowMenu($HWnd, $trackmenu, $aContext, 1)
EndFunc   ;==>_RightClick


;Author: MsCreatoR in http://www.autoitscript.com/forum/index.php?s=&showtopic=60192&view=findpost&p=453350
;Modified from Help
; Show a menu in a given GUI window which belongs to a given GUI ctrl
Func ShowMenu($HWnd, $nContextID, $nContextControlID, $iMouse = 0)
	Local $hMenu = GUICtrlGetHandle($nContextID)
	Local $iCtrlPos = ControlGetPos($HWnd, '', $nContextControlID)

	Local $X = $iCtrlPos[0]
	Local $Y = $iCtrlPos[1] + $iCtrlPos[3]

	ClientToScreen($HWnd, $X, $Y)

	If $iMouse Then
		$X = MouseGetPos(0)
		$Y = MouseGetPos(1)
	EndIf

	DllCall('user32.dll', 'int', 'TrackPopupMenuEx', 'hwnd', $hMenu, 'int', 0, 'int', $X, 'int', $Y, 'hwnd', $HWnd, 'ptr', 0)
EndFunc   ;==>ShowMenu

; Convert the client (GUI) coordinates to screen (desktop) coordinates
;From Help
Func ClientToScreen($HWnd, ByRef $X, ByRef $Y)
	Local $stPoint = DllStructCreate('int;int')

	DllStructSetData($stPoint, 1, $X)
	DllStructSetData($stPoint, 2, $Y)

	DllCall('user32.dll', 'int', 'ClientToScreen', 'hwnd', $HWnd, 'ptr', DllStructGetPtr($stPoint))

	$X = DllStructGetData($stPoint, 1)
	$Y = DllStructGetData($stPoint, 2)
	; release Struct not really needed as it is a local
	$stPoint = 0
EndFunc   ;==>ClientToScreen
#endregion
;-------------------------------------------------------------------
#ce